;---------------------------------------;
;    Daydreamers DDraw skeleton program ;
;---------------------------------------;

TITLE WIN32ASM EXAMPLE
	.686p
      .xmm
	.MODEL FLAT, STDCALL
	option casemap :none

;-----------------------------------------------------------;
;                WIN32ASM / DDRAW SSE experimental engine   ;
;-----------------------------------------------------------;
      INCLUDE \masm32\include\windows.inc
	;INCLUDE \masm32\include\gdi32.inc
	INCLUDE \masm32\include\kernel32.inc
	INCLUDE \masm32\include\user32.inc
	INCLUDE \masm32\SSE\ddraw.inc

	;INCLUDELIB \masm32\lib\gdi32.lib
	INCLUDELIB \masm32\lib\kernel32.lib
	INCLUDELIB \masm32\lib\user32.lib
	INCLUDELIB \masm32\lib\ddraw.lib

	WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD
	WndProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD
	
RETURN	MACRO	arg
	IFNB <arg>
		mov		eax, arg
	ENDIF
	ret
ENDM

LRETURN	MACRO	arg 
	IFNB <arg>
		mov		eax, arg
	ENDIF
	leave
	ret
ENDM

.DATA?
hWnd			HWND				?		; surface window
lpDD			LPDIRECTDRAW		?		; DDraw object
lpDDSPrimary	LPDIRECTDRAWSURFACE	?		; DDraw primary surface
ddsd			DDSURFACEDESC		<?>		; DDraw surface descriptor
ddscaps			DDSCAPS				<?>		; DDraw capabilities

palette			dd					256 dup (?)
table			dd					512 dup (?)
ALIGN 16
buffer            dd                            65536 dup (?)
                  
ALIGN 16
sintab            REAL4                         8096 dup (?)
lpDDPalette		dd					?

.DATA
;zero                    EQU             0

ddwidth			EQU				320		; display mode width
ddheight		EQU					320		; display mode height
ddbpp			EQU					32		; display mode color depth

szClassName		db					"S", 0	; class name
szDisplayName	EQU					<szClassName>			; window name

wc				WNDCLASSEX			< sizeof WNDCLASSEX, CS_HREDRAW or CS_VREDRAW, offset WndProc, 0, 0, , 0, 0, , 0, offset szClassName, 0 >

.CODE
start:

	INVOKE	GetModuleHandle, NULL
	INVOKE	WinMain, eax, NULL, NULL, SW_SHOWDEFAULT
	INVOKE	ExitProcess, eax


;-----------------------------------------------------------;
;                WinMain  ( entry point )                   ;
;-----------------------------------------------------------;

WinMain		PROC	hInst     :DWORD,
					hPrevInst :DWORD,
					CmdLine   :DWORD,
					CmdShow   :DWORD

	LOCAL msg  :MSG
	mov		eax, [hInst]
	mov		[wc.hInstance], eax
	;INVOKE	GetStockObject, BLACK_BRUSH
	mov eax,NULL ;to get rid of need to include gdi stuff
      mov		[wc.hbrBackground], eax

	INVOKE	RegisterClassEx, ADDR wc

; Create window at following size

	INVOKE	CreateWindowEx, 0, ADDR szClassName, ADDR szDisplayName, WS_POPUP, 0, 0, ddwidth, ddheight, NULL, NULL, hInst, NULL
	mov		[hWnd], eax

	;rem INVOKE	SetFocus, hWnd
	;rem INVOKE	ShowCursor, 0

; Initialize display

	INVOKE	DirectDrawCreate, NULL, ADDR lpDD, NULL
	DDINVOKE	SetCooperativeLevel, lpDD, hWnd, DDSCL_NORMAL or DDSCL_NOWINDOWCHANGES ; DDSCL_EXCLUSIVE or DDSCL_FULLSCREEN
	; DDINVOKE	SetDisplayMode, lpDD, ddwidth, ddheight, ddbpp
	
	mov		[ddsd.dwSize], sizeof DDSURFACEDESC
	mov		[ddsd.dwFlags], DDSD_CAPS
	mov		[ddsd.ddsCaps.dwCaps], DDSCAPS_PRIMARYSURFACE
	DDINVOKE	CreateSurface, lpDD, ADDR ddsd, ADDR lpDDSPrimary, NULL
	
	INVOKE	ShowWindow, hWnd, CmdShow

; Loop until PostQuitMessage is sent

	.WHILE 1

		INVOKE	PeekMessage, ADDR msg, NULL, 0, 0, PM_REMOVE

		.IF eax != 0
			.IF msg.message == WM_QUIT
				INVOKE	PostQuitMessage, msg.wParam
				.BREAK
			.ELSE
				INVOKE	TranslateMessage, ADDR msg
				INVOKE	DispatchMessage, ADDR msg
			.ENDIF
		.ELSE
			;INVOKE	GetFocus

			;.IF eax == hWnd

				;mov		[ddsd.dwSize], sizeof DDSURFACEDESC
				;mov		[ddsd.dwFlags], DDSD_PITCH

				;.WHILE 1
					;DDSINVOKE	mLock, lpDDSPrimary, NULL, ADDR ddsd, DDLOCK_WAIT, NULL

					;.BREAK .IF eax == DD_OK

					;.IF eax == DDERR_SURFACELOST
					;	DDSINVOKE	Restore, lpDDSPrimary
					;.ELSE
						;FATAL "Couldn't lock surface"
					;.ENDIF
				;.ENDW

				;DDINVOKE	WaitForVerticalBlank, lpDD, DDWAITVB_BLOCKBEGIN, NULL


				;call	render

				;DDSINVOKE	Unlock, lpDDSPrimary, ddsd.lpSurface


			;.ENDIF
		.ENDIF
	.ENDW
	INVOKE DestroyWindow, hWnd
	;rem.IF lpDD != NULL
	;rem	.IF lpDDSPrimary != NULL
	;rem		DDSINVOKE	Release, lpDDSPrimary
	;rem		mov		[lpDDSPrimary], NULL
	;rem	.ENDIF
      ;rem  
	;rem	DDINVOKE	Release, lpDD
	;rem	mov		[lpDD], NULL

	;rem.ENDIF

	LRETURN	msg.wParam
WinMain		ENDP


;-----------------------------------------------------------;
;             Window Proc  ( handle events )                ;
;-----------------------------------------------------------;

WndProc		PROC	hWin   :DWORD,
					uMsg   :DWORD,
					wParam :DWORD,
					lParam :DWORD

	   .IF uMsg == WM_KEYDOWN
		.IF wParam == VK_ESCAPE
			INVOKE	PostQuitMessage, NULL
			RETURN	0 
	   .ENDIF
      .ELSEIF uMsg == WM_DESTROY
		INVOKE	PostQuitMessage, NULL
		RETURN	0 
	.ENDIF

	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam

	ret
WndProc		ENDP

END start

